import java.applet.Applet;
import java.awt.Color;
import java.io.IOException;
import java.io.OutputStream;
import java.io.StringWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import quadbase.common.param.HtmlParameterPageWriter;
import quadbase.common.param.ParameterPage;
import quadbase.reportdesigner.ReportAPI.QbReport;


public class CustomParamPage extends HttpServlet{
	static final long serialVersionUID = 1; 	
	String reportLocation = "CustomParamPage.pak";
	String servletAddress = "127.0.0.1";
	int servletPort = 8080;
	String servletDirectory = "servlet/";
	int format = QbReport.PDF;
	
	public void doGet(HttpServletRequest req, HttpServletResponse res) 
	throws ServletException, IOException {
		
		res.setContentType("text/html");
		OutputStream toClient = res.getOutputStream();
		try {
			
			// Do not connect to EspressManager
			QbReport.setEspressManagerUsed(false);

			// Create the ObReport object using back-up data
			QbReport report = new QbReport((Applet)null, reportLocation, false, false, false, true, false);
			report.setDynamicExport(true, servletAddress, servletPort);
			report.setServletDirectory(servletDirectory);
			
			// Specify report template location and desired export format
			ParameterPage paramPage = report.getParameterPage(reportLocation, null, format, null);
			// Writer writer = new PrintWriter(toClient);

			paramPage.setTableLayout(ParameterPage.TABLE_LAYOUT_HORIZONTAL);
			paramPage.setTextSize(2);
			paramPage.setTextColor(new Color(90,0,0));
			
			
			StringWriter tempStringWriter = new StringWriter();

			MyHtmlParameterPageWriter paramPageWriter = new MyHtmlParameterPageWriter(paramPage, tempStringWriter);
			

			// Create head of html page, adding title and  specification
			paramPageWriter.writeHead();
			
			
			paramPageWriter.printCustom();
			
			String paramHTMLPage = tempStringWriter.toString();
			toClient.write(paramHTMLPage.getBytes());
					
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	
	private class MyHtmlParameterPageWriter extends HtmlParameterPageWriter{
		public MyHtmlParameterPageWriter(ParameterPage pp, StringWriter sw) {
			super(pp,sw);
		}
		public void printCustom() {
			try {
				write("<BODY bgcolor=#FDFAED>");
				
				write("<FORM action = \"" + servletName +"\" target=\"main\" method = GET>\n");
				write("<TABLE ALIGN=\"CENTER\"><TR><TD><IMG src=http://www.quadbase.com/FurnitureImages/Woodview.gif></TD>");
				write("<TD WIDTH=50></TD><TD>");
				writeParamTable();
				
				write("</TD><TD WIDTH=50></TD><TD>");
				writeSubmitButton();
				write("</TD>");
				write("</TR></TABLE>");
				
			    writeHiddenParamValue("ReportFilePath", reportLocation);
			    write("\n");
				
			    writeHiddenParamValue("ReportExportFormat", ""+format);
				write("\n");
			    
				writeHiddenParamValue("ServerName", servletAddress);
			    write("\n");
			    writeHiddenParamValue("ServletRunnerPort", ""+servletPort);
			    
			    write("\n");
				writeHiddenParamValue("ServletDirectory", servletDirectory);	

				write("\n</FORM>");
				html.bodyEnd();
				html.htmlEnd();

			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
